(defun C:XR2B ;Xref 2 Block by Donald Pirl, CIS: 71174,1113, Internet:dpirl@crl.com
  (/ xre xrd xrn xrt ib ip ra xn xr ldat lnme flgs flgt flnm flnl)
  (command "._undo" "group")
  (while (not xrt)
    (if xre (redraw xre 4))
    (setq 
      xre (car (entsel "\nSelect Xref to insert: "))
      xrd (if xre (entget xre))
      xrn (if (assoc '2 xrd) (cdr (assoc '2 xrd)))
      xrt (if xrn (tblsearch "BLOCK" xrn))
      xrt (if xrt (= 4 (logand 4 (cdr (assoc '70 xrt)))))
    )
    (if xre (redraw xre 3))
    (initget "Y N")
    (setq 
      ib (if xrn (getkword (strcat "\nInsert " xrn "? <Y>/N ")))
      ib (if xrn (if ib ib "Y"))
      xrt (if xrn (if (= ib "Y") xrt))
    )
  )
  (setq
    ip (cdr (assoc '10 xrd))
    ra (/ (* 180 (cdr (assoc '50 xrd))) pi)
    xn (cdr (assoc '2 xrd))
    xr (strcat "*" (getvar "dwgprefix") xn)
    ldat (tblnext "LAYER" T)
  )
  (while ldat
    (setq
      lnme (cdr (assoc '2 ldat))
      flgs (if (wcmatch lnme (strcat xn "|*")) (cdr (assoc '70 ldat)))
      flgt (if (and flgs (= 1 (logand 1 flgs))) T)
      flnm
      (if
        (and flgs flgt)
        (substr lnme (+ 2 (strlen xn)))
      )
      flnl 
      (cond 
        ( (and (not flgt) flnl) flnl)
        ( (and flgt (not flnl)) flnm)
        ( (and flgt flnl) (strcat flnl "," flnm) )
      )
      ldat (tblnext "LAYER")
    )
  )
  (command 
    "._xref" "D" xrn
    "._insert" xr ip "1" ra
    "._layer" "F" flnl ""
    "._undo" "end"
  )
  (princ)
)
